#!/usr/bin/perl

# LiLith: http forms scanner/injector
# by <michael@scanit.be>
#
# not the usual http scanner, this will look for variable and 'try' to
# exploit it, or at least report it.  
#
# (c) 2003,2004 Michael Hendrickx <michael@scanit.be>
#
# thanks to all people who believe in me.
#
# She has come from the shadows of the dreamworld

use strict;
use Class::ISA;
use LWP::UserAgent;
use URI::URL;
use HTML::Form;
use HTML::LinkExtor;
use Getopt::Std;

my ($host, $proxy,  $dir, $v, $agent, $serverinfo, $request, $logfile);
my ($cred_un, $cred_pw, %options,  $timeout, $flag_poison, $pause, $cookies, $c_jar);
my ($prox_un, $prox_pw);
my (@links, @visited_links, @dynvisurls, @agents, @illegal, $page);

    $serverinfo  = 0;   # default fetch server version
    $v           = 0;   # verbosity
    $timeout     = 60;  # http timeout (seconds)
    $flag_poison = 1;   # by default, try to inject stuff
    $pause       = 0;   # by default, no pause between requests
    $cookies	 = 1;
        
    my %ver = (         # just to keep track of changes
        maj=>0,         # major
        min=>4,         # minor
        rev=>"c"        # revision
    );  

    $agent = "LiLith v".$ver{maj}.".".$ver{min}.$ver{rev};  # can be changed with -a arg

@agents = (
    "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.5) Gecko/20031027",
    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)",
    "Lynx/2.8.4rel.1 libwww-FM/2.14 SSL-MM/1.4.1 OpenSSL/0.9.7b",
    "curl/7.9.4 (i686-pc-linux-gnu) libcurl 7.9.4 (OpenSSL 0.9.7b)"
    );

@illegal = ( "'", "\"", "\|", "\%", "\(", "\$",
             ";", ",", "&", " ", "[", "*", "?", 
             "test", "", "/../../test", "123",
             "%00"); # bad characters 

# --- main() ---------------------------------------

print "LiLith v".$ver{maj}.".".$ver{min}.$ver{rev}.
      " : http forms scanner/injector\nby michael\@scanit.be\n\n";

if(@ARGV<2){ usage(); }
getopts('ivsh:p:u:d:a:T:f:',\%options);
chkopts(\%options);
sanitize();
display_info();
empty_cookie_jar();
unless ($serverinfo eq 1) { get_server_version(); }
print "\n";
spider($request);
my $nvl = @visited_links;

# tempy
if($cookies and $c_jar){ print $c_jar->as_string; }

print "\nLiLith v".$ver{maj}.".".$ver{min}.$ver{rev}." completed\n", $nvl, " hyperlink";
if($nvl eq 1){ print " was"; } else { print "s were"; } 
print " followed.\n";

# --------------------------------------------------
# called functions of the program.  

# usage() : prints how to use it and exits
sub usage {
    print "usage: $0 [options] -h <host>\n";
    print "with following [options]:\n";
    print "  -h <host>        : target (<host:port>) (this argument is mandatory)\n";
    print "  -a <agent>       : agent to use (-a 0 for list)\n";
    print "  -u <user:pass>   : basic authentication credentials\n";
    print "  -d <dir>         : <dir> (or file) where to start [default: /]\n";
    print "  -p <proxy>       : proxy server (proxy:port)\n";
    print "  -U <user:pass>   : proxy authentication credentials\n";
    print "  -T <delay>       : wait <delay> seconds between requests\n";
    print "  -f <file>        : if defined, output of 'errors' is logged to <file>\n";
    print "  -s               : do not attempt to guess server version\n";
    print "  -v               : verbosity\n";
    print "  -i               : don't inject any poison\n";
    print "  -c               : ignore cookies presented by <host>\n";
    print "\n";
    exit;
}

# empty_cookie_jar() : makes an empty cookie jar
sub empty_cookie_jar {
    return if $cookies;
    use HTTP::Cookies;
    $c_jar = HTTP::Cookies->new({});
}

# chkopts() : check options (getopt) and parses
sub chkopts {
    my $opt = shift; 
    if(defined $opt->{a}){ 
        if($opt->{a} eq "0"){
            print "Available agents:\n";
            for(my $i=0;$i<@agents;$i++){ print " + ".($i+1).": ".$agents[$i]."\n"; }
            print " + default: ".$agent."\n\n"; exit(0);
        }
        # get the element-1 from the @agents list
        if($opt->{a}=~/[0-9]/){ 
            if($agents[($opt->{a})-1] ne ""){ $agent = $agents[($opt->{a})-1]; }
        }
    }        
    if(defined $opt->{h}){ $host = $opt->{h}; }
        else { print "host argument needed\n"; &usage; }
    if(defined $opt->{p}){ $proxy = $opt->{p}; }
    if(defined $opt->{v}){ $v++; }
    if(defined $opt->{u}){ ($cred_un, $cred_pw) = split /:/, $opt->{u}; }
    if(defined $opt->{U}){ ($prox_un, $prox_pw) = split /:/, $opt->{U}; }
    if(defined $opt->{d}){ $dir = $opt->{d}; }
    if(defined $opt->{s}){ $serverinfo = 1; }
    if(defined $opt->{i}){ $flag_poison = 0; }
    if(defined $opt->{T}){ $pause = $opt->{T}; }
    if(defined $opt->{f}){ $logfile = $opt->{f}; }
    if(defined $opt->{c}){ $cookies = 0; }
}

# sanitize :sanity checks for proxy, target, ...
sub sanitize(){
    if($host !~ /http\:\/\//){ $host = "http://$host"; }
    if($proxy){ if($proxy !~ /http\:\/\//){ $proxy = "http://$proxy"; }}
    if($prox_un && !$proxy){ print " [e] How can you set proxy credentials without\n".
				   "     specifying a proxy?\n"; exit; }
    if(defined $dir && (substr($dir,0,1) ne "/")){ $dir = "/".$dir; }
    $request = $host.$dir;
}

# get_server_version() : try to determine what server we're dealing with
sub get_server_version(){
    
    my $svrver_ua = LWP::UserAgent->new();
    my ($res, $prefix, @probes, $final, %cnt, $max);

    # fill in proxy if needed
    if($proxy){ $svrver_ua->proxy('http', $proxy); }
    if($cookies){ $svrver_ua->cookie_jar($c_jar); }    

    # get request
    $res = $svrver_ua->get("$host");
    push @probes, $res->headers->server;
    
    sleep $pause;

    # head request
    $res = $svrver_ua->head("$host");
    push @probes, $res->headers->server;

    sleep $pause;
    
    # get non existing file
    $res = $svrver_ua->get("$host/banner$$.jpg");
    push @probes, $res->headers->server;
    
    # matching algorythm, thanks to alla@scanit.be for this one    
    foreach my $a (@probes){ $cnt{$a}++; }
    foreach my $b(keys %cnt){
        if($cnt{$b}>$max){ $max = $cnt{$b}; $final = $b; }
    }
    
    print " + server:        ";
    if($final){print $final."\n";} else {print "could not be determined\n";}
    
}

# display_info() : print some info information prior to the scan    
sub display_info {
    $host      && print " + target:        $host\n";
    $proxy     && print " + proxy:         $proxy\n";
    $cred_un   && print " + cred auth:     $cred_un:$cred_pw\n";
    $dir       && print " + directory:     $dir\n";
    $pause     && print " + delay:         $pause seconds\n";
}

# look_for_error() : checks if request made any error, 500, ...
sub look_for_error {
    my $response = shift;
    my $poison = shift;
    my $inputname = shift;
    
    # TODO: more filtering /regex/ magic to see if an error or not, if
    # $v is on, print everything.. also with a normal HTTP 200
    # except for 404's
    
    if($logfile ne ""){
        open(FILE, "+>>", $logfile) || die " [e] Error: cannot open $logfile\n";
        print FILE "-" x 72, "\n";
        print FILE ("-" x 72), "\n", $response->base." : \"".$poison."\" in ".
                    $inputname.": ".$response->status_line."\n\n".
                    $response->content."\n".("-" x 72)."\n\n";
        close(FILE);
    }
    
    if($v>0){
        print " [e] ".$response->base." gave HTTP:".$response->code." with \"".$poison.
        "\" in ".$inputname."\n";            
    }
    
    if(!($response->is_success)){
        if($response->code ne 404){
            if($v eq 0){
            print " [e] ".$response->base." gave HTTP:".$response->code." with \"".$poison.
            "\" in ".$inputname."\n";                    
            } # $v
        } # 404
    }
    
    if($response->content =~ /SQL/){ # sql injection?
        if($response->content =~ /Unclosed quotation mark/ or # iis
           $response->content =~ /not a valid MySQL/){        # mysql   
            print "  +--[!] SQL injection: ".$response->base." (".$inputname.")\n";
            return;
        }
    }
    
    if($response->content =~ /[Microsoft][ODBC Microsoft Access Driver]/){
	print "  +--[i]] SQL injection: ".$response->base." (".$inputname.")\n";
            return;
    }
    
    if($response->content =~ /error/ or $response->content =~ /Error/){
        printf "  +--[!] Misc error: ".$response->base." (".$inputname.")\n";
	return;
    }    
}

# dynurl() : if $_ is a dynamic url- dissect and try some poison :)
sub dynurl {
    my $tmpurl = shift;
    my (@tmpuv, @tmpvc, %url_vars, $va);
    my ($tmpreq, $req_dyn, $dyn_ua, $inj_resp); # our request

    return if($flag_poison eq 0);
            
    # get variables and values in %array
    @tmpuv = split /\?/, $tmpurl;
    @tmpvc = split /\&/, $tmpuv[1]; # 0 is the url     
    
    # check if we had this one already
    foreach my $vlink (@dynvisurls){ if($vlink eq $tmpuv[0]){ return; }}      
    foreach $va (@tmpvc){ my($a,$b) = split(/=/,$va); $url_vars{$a} = $b; }
    foreach my $n (keys %url_vars){
        foreach my $poison (@illegal){
            my $backup = $url_vars{$n}; 
            $url_vars{$n} = $poison;
            $tmpreq = $tmpuv[0]."?";
            # assemble URL again
            foreach my $o (keys %url_vars){ # yes, ugly code, 3 * foreach
                if($o eq $n){ $tmpreq .= $n."=".$url_vars{$n}."&"; }
                else { $tmpreq .= $o."=".$url_vars{$o}."&"; }
            }
            chop $tmpreq;
            $dyn_ua = LWP::UserAgent->new(timeout=>$timeout,agent=>$agent);
            if($proxy){ $dyn_ua->proxy('http', $proxy); } 
	    if($cookies){ $dyn_ua->cookie_jar($c_jar); }    
	    
	    $req_dyn = HTTP::Request->new(GET=>$tmpreq);
	    if($cred_un){ $req_dyn->authorization_basic($cred_un, $cred_pw); }
	    if($proxy and $prox_un){ $req_dyn->proxy_authentication_basic($prox_un, $prox_pw); }
	    	    
            $inj_resp = $dyn_ua->request($req_dyn);
            look_for_error($inj_resp, $poison, $n);
            $url_vars{$n} = $backup;
            sleep $pause;
        }
    }
    push @dynvisurls, $tmpuv[0];
}


# getforms() : get the <form> tags, dissects and injects some data
sub getforms{
    my $buffer = shift;
    my @forms = HTML::Form->parse($buffer);    
    my $nforms = @forms;

    if($v>0){ 
	print " + [i] found ".$nforms." form"; 
        if($nforms ne 1){ print "s"; }
        if($nforms eq 0){ print ".\n\n"; return } else { print ":\n"; }
    }
    
    for(my $i=0;$i<$nforms;$i++){    
        sleep $pause;
        if($v>0){ print " +-- [i] $i : ".$forms[$i]->method." - ".$forms[$i]->action."\n"; }
        if($forms[$i]->action =~ /\?/){ dynurl($forms[$i]->action); }
        
        # see the different inputs
        my @inputs = $forms[$i]->inputs;
        my $ninputs = @inputs;
        
        if($v>0){ # if verbosity, print all inputs
            print "     + [i] found $ninputs input"; 
            if($ninputs ne 1){ print "s"; }            
            if($ninputs eq 0){ print ".\n"; return } else { print ":\n"; }
            for(my $j=0;$j<$ninputs;$j++){ 
                print "     +-- [i] ".($inputs[$j]->type)."\t: ".$inputs[$j]->name." (\"".$inputs[$j]->value."\")\n"; 
            }
            print "\n";               
            
        } # $v
        
        # if there is a submit button, inject poison
        if($flag_poison eq 1){
            my $clickcont = $forms[$i]->click;
            if(length $clickcont->content){  # it is submittable
                # inject bad things :) - each control seperatly
                for(my $j=0;$j<$ninputs;$j++){ 
		    $clickcont = "";

                    if($inputs[$j]->type ne "button" and $inputs[$j]->type ne "image"){ # if not a submit button/image
                        # TODO: proper test directory traversal                        

                        foreach my $poison (@illegal){
                            my ($old_value, $inj_ua, $inj_resp);
                            sleep $pause;                        
                            $old_value = $inputs[$j]->value;
                            
                        # fucking perl - that's why C is still around
                        # C gives you power and doesn't hold your hand
                        # i can't even change the value of an <option>
                        
                            if($inputs[$j]->type eq "option"){
                                print "  +--[O] manually check $request (read only: ".$inputs[$j]->name.") - Sorry (blame perl)\n\n";
                                return;
                            }
                            else
                            {                            
				my $tmpreq = $forms[$i]->click; # clone, to set auth headers
                                $inputs[$j]->value($poison);    
                                $inj_ua = LWP::UserAgent->new(timeout=>$timeout,agent=>$agent); 
                                if($proxy){ $inj_ua->proxy('http', $proxy); }                            
				if($cookies){ $inj_ua->cookie_jar($c_jar); } 
				if($proxy and $prox_un){ $tmpreq->proxy_authorization_basic($prox_un, $prox_pw); }
				if($cred_un){ $tmpreq->auhtorization($cred_un, $cred_pw); }				
                                $inj_resp = $inj_ua->request($tmpreq); 
				$tmpreq = "";
                                look_for_error($inj_resp, $poison, $inputs[$j]->name);
                                $inputs[$j]->value($old_value);
                            }   # type ne "option"
                        } # $poison                                                  
                    } # $inputs[$j]->type not image or submit
                } # $ninputs             
            } # $blah->content (submit possible)
        } # $flag_poison        
    } # for @forms 
}

# cb :  links callback (HTML::LinkExtor) | check for duplicates
sub cb {
    my ($tag, %attr) = @_;
    my $ok = 0;

    if($tag ne "a" and $tag ne "frame"){ return; }
    
    # make absolute to eliminate /data/a.html != www.a.com/data/a.html
    
    %attr = map { $_ = url($_, $page->base)->abs; } %attr;    
    foreach my $link (values %attr){        
        # leave out anchors (blah.html#top, blah.html#item2...)
        $link =~ s/#.+//g;
        foreach my $vlink (@visited_links){ if($vlink eq $link){ $link = ""; } }  
        if($link ne ""){ foreach my $alink (@links){ if($alink eq $link){ $link = ""; }}}
        if($link ne ""){ push @links, $link; }
    }        
}
    
# spider() : analyses the website, getting out links, getforms(),.. 
sub spider {
    $request = shift;
    my ($spider_ua);    

    my $req_obj = HTTP::Request->new(GET=>$request);
    if($cred_un){ $req_obj->authorization_basic($cred_un, $cred_pw); }
    if($proxy and $prox_un){ $req_obj->proxy_authorization_basic($prox_un, $prox_pw); }
        
    $spider_ua = LWP::UserAgent->new(timeout=>$timeout,agent=>$agent);
    
    if($proxy){ $spider_ua->proxy('http', $proxy); }
    if($cookies){ $spider_ua->cookie_jar($c_jar); }        
    if($request =~ /\?/){ dynurl($request); }
    
    $page = $spider_ua->request($req_obj); 
    shift @links;
    push @visited_links, $request;        
    
    if($page->code == 401){
	# authentication needed
	if($cred_un eq ""){
	    my $realm = $page->header("www-authenticate");
	    $realm =~ s/Basic//g;
	    $realm =~ s/realm=//g;
	    print " [e] Authentication needed: (realm: $realm)\n";
	    print "     Please set proper credentials\n";
	    return;
	} else { # creds filled in, but (probably) wrong ones
	    print " [e] Authentication failed (wrong username/password)\n";
	    return;
	}
    }
    
    if($page->code == 407){
	print " [e] Proxy authentication needed. Set proper credentials\n";
	return;
    }
                
    if($page->content eq ""){ 
        # some sites give false positives here, like security focus 200's seem to be 403's
        unless($page->is_success){
            print " [e] error getting ".$request.": ".$page->status_line."\n";
            return; 
        }
    }
    
    # spider the page for forms
    if($v>0){ print " [i] ".$request."\n"; }
    getforms($page);
    
    # extract links and recursive call    
    my $parser = HTML::LinkExtor->new(\&cb);    
    sleep $pause;
    @links = map { $_ = url($_, $page->base)->abs; } @links;    
    @visited_links = map { $_ = url($_, $page->base)->abs; } @visited_links;    
    my $linres = $spider_ua->request(HTTP::Request->new(GET=>$request), sub {$parser->parse($_[0])});
    if($links[0]){ spider($links[0]); }
}

